1#!/bin/sh
2#
3# git-submodules.sh: add, init, update or list git submodules
4#
5# Copyright (c) 2007 Lars Hjemli
6
7dashless=$(basename "$0" | sed -e 's/-/ /')
8USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13 or: $dashless [--quiet] foreach [--recursive] <command>
14 or: $dashless [--quiet] sync [--] [<path>...]"
15OPTIONS_SPEC=
16. git-sh-setup
17. git-sh-i18n
18. git-parse-remote
19require_work_tree
20
21command=
22branch=
23force=
24reference=
25cached=
26recursive=
27init=
28files=
29nofetch=
30update=
31prefix=
32
33# Resolve relative url by appending to parent's url
34resolve_relative_url ()
35{
36 remote=$(get_default_remote)
37 remoteurl=$(git config "remote.$remote.url") ||
38 die "$(eval_gettext "remote (\$remote) does not have a url defined in .git/config")"
39 url="$1"
40 remoteurl=${remoteurl%/}
41 sep=/
42 while test -n "$url"
43 do
44 case "$url" in
45 ../*)
46 url="${url#../}"
47 case "$remoteurl" in
48 */*)
49 remoteurl="${remoteurl%/*}"
50 ;;
51 *:*)
52 remoteurl="${remoteurl%:*}"
53 sep=:
54 ;;
55 *)
56 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
57 ;;
58 esac
59 ;;
60 ./*)
61 url="${url#./}"
62 ;;
63 *)
64 break;;
65 esac
66 done
67 echo "$remoteurl$sep${url%/}"
68}
69
70#
71# Get submodule info for registered submodules
72# $@ = path to limit submodule list
73#
74module_list()
75{
76 git ls-files --error-unmatch --stage -- "$@" |
77 perl -e '
78 my %unmerged = ();
79 my ($null_sha1) = ("0" x 40);
80 while (<STDIN>) {
81 chomp;
82 my ($mode, $sha1, $stage, $path) =
83 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
84 next unless $mode eq "160000";
85 if ($stage ne "0") {
86 if (!$unmerged{$path}++) {
87 print "$mode $null_sha1 U\t$path\n";
88 }
89 next;
90 }
91 print "$_\n";
92 }
93 '
94}
95
96#
97# Map submodule path to submodule name
98#
99# $1 = path
100#
101module_name()
102{
103 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
104 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
105 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
106 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
107 test -z "$name" &&
108 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$path'")"
109 echo "$name"
110}
111
112#
113# Clone a submodule
114#
115# Prior to calling, cmd_update checks that a possibly existing
116# path is not a git repository.
117# Likewise, cmd_add checks that path does not exist at all,
118# since it is the location of a new submodule.
119#
120module_clone()
121{
122 path=$1
123 url=$2
124 reference="$3"
125
126 if test -n "$reference"
127 then
128 git-clone "$reference" -n "$url" "$path"
129 else
130 git-clone -n "$url" "$path"
131 fi ||
132 die "$(eval_gettext "Clone of '\$url' into submodule path '\$path' failed")"
133}
134
135#
136# Add a new submodule to the working tree, .gitmodules and the index
137#
138# $@ = repo path
139#
140# optional branch is stored in global branch variable
141#
142cmd_add()
143{
144 # parse $args after "submodule ... add".
145 while test $# -ne 0
146 do
147 case "$1" in
148 -b | --branch)
149 case "$2" in '') usage ;; esac
150 branch=$2
151 shift
152 ;;
153 -f | --force)
154 force=$1
155 ;;
156 -q|--quiet)
157 GIT_QUIET=1
158 ;;
159 --reference)
160 case "$2" in '') usage ;; esac
161 reference="--reference=$2"
162 shift
163 ;;
164 --reference=*)
165 reference="$1"
166 shift
167 ;;
168 --)
169 shift
170 break
171 ;;
172 -*)
173 usage
174 ;;
175 *)
176 break
177 ;;
178 esac
179 shift
180 done
181
182 repo=$1
183 path=$2
184
185 if test -z "$path"; then
186 path=$(echo "$repo" |
187 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
188 fi
189
190 if test -z "$repo" -o -z "$path"; then
191 usage
192 fi
193
194 # assure repo is absolute or relative to parent
195 case "$repo" in
196 ./*|../*)
197 # dereference source url relative to parent's url
198 realrepo=$(resolve_relative_url "$repo") || exit
199 ;;
200 *:*|/*)
201 # absolute url
202 realrepo=$repo
203 ;;
204 *)
205 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
206 ;;
207 esac
208
209 # normalize path:
210 # multiple //; leading ./; /./; /../; trailing /
211 path=$(printf '%s/\n' "$path" |
212 sed -e '
213 s|//*|/|g
214 s|^\(\./\)*||
215 s|/\./|/|g
216 :start
217 s|\([^/]*\)/\.\./||
218 tstart
219 s|/*$||
220 ')
221 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
222 die "$(eval_gettext "'\$path' already exists in the index")"
223
224 if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
225 then
226 (
227 eval_gettext "The following path is ignored by one of your .gitignore files:
228\$path
229Use -f if you really want to add it." &&
230 echo
231 ) >&2
232 exit 1
233 fi
234
235 # perhaps the path exists and is already a git repo, else clone it
236 if test -e "$path"
237 then
238 if test -d "$path"/.git -o -f "$path"/.git
239 then
240 eval_gettext "Adding existing repo at '\$path' to the index"; echo
241 else
242 die "$(eval_gettext "'\$path' already exists and is not a valid git repo")"
243 fi
244
245 case "$repo" in
246 ./*|../*)
247 url=$(resolve_relative_url "$repo") || exit
248 ;;
249 *)
250 url="$repo"
251 ;;
252 esac
253 git config submodule."$path".url "$url"
254 else
255
256 module_clone "$path" "$realrepo" "$reference" || exit
257 (
258 clear_local_git_env
259 cd "$path" &&
260 # ash fails to wordsplit ${branch:+-b "$branch"...}
261 case "$branch" in
262 '') git checkout -f -q ;;
263 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
264 esac
265 ) || die "$(eval_gettext "Unable to checkout submodule '\$path'")"
266 fi
267
268 git add $force "$path" ||
269 die "$(eval_gettext "Failed to add submodule '\$path'")"
270
271 git config -f .gitmodules submodule."$path".path "$path" &&
272 git config -f .gitmodules submodule."$path".url "$repo" &&
273 git add --force .gitmodules ||
274 die "$(eval_gettext "Failed to register submodule '\$path'")"
275}
276
277#
278# Execute an arbitrary command sequence in each checked out
279# submodule
280#
281# $@ = command to execute
282#
283cmd_foreach()
284{
285 # parse $args after "submodule ... foreach".
286 while test $# -ne 0
287 do
288 case "$1" in
289 -q|--quiet)
290 GIT_QUIET=1
291 ;;
292 --recursive)
293 recursive=1
294 ;;
295 -*)
296 usage
297 ;;
298 *)
299 break
300 ;;
301 esac
302 shift
303 done
304
305 toplevel=$(pwd)
306
307 module_list |
308 while read mode sha1 stage path
309 do
310 if test -e "$path"/.git
311 then
312 say "$(eval_gettext "Entering '\$prefix\$path'")"
313 name=$(module_name "$path")
314 (
315 prefix="$prefix$path/"
316 clear_local_git_env
317 cd "$path" &&
318 eval "$@" &&
319 if test -n "$recursive"
320 then
321 cmd_foreach "--recursive" "$@"
322 fi
323 ) ||
324 die "$(eval_gettext "Stopping at '\$path'; script returned non-zero status.")"
325 fi
326 done
327}
328
329#
330# Register submodules in .git/config
331#
332# $@ = requested paths (default to all)
333#
334cmd_init()
335{
336 # parse $args after "submodule ... init".
337 while test $# -ne 0
338 do
339 case "$1" in
340 -q|--quiet)
341 GIT_QUIET=1
342 ;;
343 --)
344 shift
345 break
346 ;;
347 -*)
348 usage
349 ;;
350 *)
351 break
352 ;;
353 esac
354 shift
355 done
356
357 module_list "$@" |
358 while read mode sha1 stage path
359 do
360 # Skip already registered paths
361 name=$(module_name "$path") || exit
362 url=$(git config submodule."$name".url)
363 test -z "$url" || continue
364
365 url=$(git config -f .gitmodules submodule."$name".url)
366 test -z "$url" &&
367 die "$(eval_gettext "No url found for submodule path '\$path' in .gitmodules")"
368
369 # Possibly a url relative to parent
370 case "$url" in
371 ./*|../*)
372 url=$(resolve_relative_url "$url") || exit
373 ;;
374 esac
375
376 git config submodule."$name".url "$url" ||
377 die "$(eval_gettext "Failed to register url for submodule path '\$path'")"
378
379 upd="$(git config -f .gitmodules submodule."$name".update)"
380 test -z "$upd" ||
381 git config submodule."$name".update "$upd" ||
382 die "$(eval_gettext "Failed to register update mode for submodule path '\$path'")"
383
384 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$path'")"
385 done
386}
387
388#
389# Update each submodule path to correct revision, using clone and checkout as needed
390#
391# $@ = requested paths (default to all)
392#
393cmd_update()
394{
395 # parse $args after "submodule ... update".
396 orig_flags=
397 while test $# -ne 0
398 do
399 case "$1" in
400 -q|--quiet)
401 GIT_QUIET=1
402 ;;
403 -i|--init)
404 init=1
405 ;;
406 -N|--no-fetch)
407 nofetch=1
408 ;;
409 -f|--force)
410 force=$1
411 ;;
412 -r|--rebase)
413 update="rebase"
414 ;;
415 --reference)
416 case "$2" in '') usage ;; esac
417 reference="--reference=$2"
418 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
419 shift
420 ;;
421 --reference=*)
422 reference="$1"
423 ;;
424 -m|--merge)
425 update="merge"
426 ;;
427 --recursive)
428 recursive=1
429 ;;
430 --)
431 shift
432 break
433 ;;
434 -*)
435 usage
436 ;;
437 *)
438 break
439 ;;
440 esac
441 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
442 shift
443 done
444
445 if test -n "$init"
446 then
447 cmd_init "--" "$@" || return
448 fi
449
450 cloned_modules=
451 module_list "$@" | {
452 err=
453 while read mode sha1 stage path
454 do
455 if test "$stage" = U
456 then
457 echo >&2 "Skipping unmerged submodule $path"
458 continue
459 fi
460 name=$(module_name "$path") || exit
461 url=$(git config submodule."$name".url)
462 update_module=$(git config submodule."$name".update)
463 if test -z "$url"
464 then
465 # Only mention uninitialized submodules when its
466 # path have been specified
467 test "$#" != "0" &&
468 say "$(eval_gettext "Submodule path '\$path' not initialized
469Maybe you want to use 'update --init'?")"
470 continue
471 fi
472
473 if ! test -d "$path"/.git -o -f "$path"/.git
474 then
475 module_clone "$path" "$url" "$reference"|| exit
476 cloned_modules="$cloned_modules;$name"
477 subsha1=
478 else
479 subsha1=$(clear_local_git_env; cd "$path" &&
480 git rev-parse --verify HEAD) ||
481 die "$(eval_gettext "Unable to find current revision in submodule path '\$path'")"
482 fi
483
484 if ! test -z "$update"
485 then
486 update_module=$update
487 fi
488
489 if test "$subsha1" != "$sha1"
490 then
491 subforce=$force
492 # If we don't already have a -f flag and the submodule has never been checked out
493 if test -z "$subsha1" -a -z "$force"
494 then
495 subforce="-f"
496 fi
497
498 if test -z "$nofetch"
499 then
500 # Run fetch only if $sha1 isn't present or it
501 # is not reachable from a ref.
502 (clear_local_git_env; cd "$path" &&
503 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
504 test -z "$rev") || git-fetch)) ||
505 die "$(eval_gettext "Unable to fetch in submodule path '\$path'")"
506 fi
507
508 # Is this something we just cloned?
509 case ";$cloned_modules;" in
510 *";$name;"*)
511 # then there is no local change to integrate
512 update_module= ;;
513 esac
514
515 must_die_on_failure=
516 case "$update_module" in
517 rebase)
518 command="git rebase"
519 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$path'")"
520 say_msg="$(eval_gettext "Submodule path '\$path': rebased into '\$sha1'")"
521 must_die_on_failure=yes
522 ;;
523 merge)
524 command="git merge"
525 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$path'")"
526 say_msg="$(eval_gettext "Submodule path '\$path': merged in '\$sha1'")"
527 must_die_on_failure=yes
528 ;;
529 *)
530 command="git checkout $subforce -q"
531 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$path'")"
532 say_msg="$(eval_gettext "Submodule path '\$path': checked out '\$sha1'")"
533 ;;
534 esac
535
536 if (clear_local_git_env; cd "$path" && $command "$sha1")
537 then
538 say "$say_msg"
539 elif test -n "$must_die_on_failure"
540 then
541 die_with_status 2 "$die_msg"
542 else
543 err="${err};$die_msg"
544 continue
545 fi
546 fi
547
548 if test -n "$recursive"
549 then
550 (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags")
551 res=$?
552 if test $res -gt 0
553 then
554 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$path'")"
555 if test $res -eq 1
556 then
557 err="${err};$die_msg"
558 continue
559 else
560 die_with_status $res "$die_msg"
561 fi
562 fi
563 fi
564 done
565
566 if test -n "$err"
567 then
568 OIFS=$IFS
569 IFS=';'
570 for e in $err
571 do
572 if test -n "$e"
573 then
574 echo >&2 "$e"
575 fi
576 done
577 IFS=$OIFS
578 exit 1
579 fi
580 }
581}
582
583set_name_rev () {
584 revname=$( (
585 clear_local_git_env
586 cd "$1" && {
587 git describe "$2" 2>/dev/null ||
588 git describe --tags "$2" 2>/dev/null ||
589 git describe --contains "$2" 2>/dev/null ||
590 git describe --all --always "$2"
591 }
592 ) )
593 test -z "$revname" || revname=" ($revname)"
594}
595#
596# Show commit summary for submodules in index or working tree
597#
598# If '--cached' is given, show summary between index and given commit,
599# or between working tree and given commit
600#
601# $@ = [commit (default 'HEAD'),] requested paths (default all)
602#
603cmd_summary() {
604 summary_limit=-1
605 for_status=
606 diff_cmd=diff-index
607
608 # parse $args after "submodule ... summary".
609 while test $# -ne 0
610 do
611 case "$1" in
612 --cached)
613 cached="$1"
614 ;;
615 --files)
616 files="$1"
617 ;;
618 --for-status)
619 for_status="$1"
620 ;;
621 -n|--summary-limit)
622 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
623 then
624 :
625 else
626 usage
627 fi
628 shift
629 ;;
630 --)
631 shift
632 break
633 ;;
634 -*)
635 usage
636 ;;
637 *)
638 break
639 ;;
640 esac
641 shift
642 done
643
644 test $summary_limit = 0 && return
645
646 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
647 then
648 head=$rev
649 test $# = 0 || shift
650 elif test -z "$1" -o "$1" = "HEAD"
651 then
652 # before the first commit: compare with an empty tree
653 head=$(git hash-object -w -t tree --stdin </dev/null)
654 test -z "$1" || shift
655 else
656 head="HEAD"
657 fi
658
659 if [ -n "$files" ]
660 then
661 test -n "$cached" &&
662 die "$(gettext -- "--cached cannot be used with --files")"
663 diff_cmd=diff-files
664 head=
665 fi
666
667 cd_to_toplevel
668 # Get modified modules cared by user
669 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
670 sane_egrep '^:([0-7]* )?160000' |
671 while read mod_src mod_dst sha1_src sha1_dst status name
672 do
673 # Always show modules deleted or type-changed (blob<->module)
674 test $status = D -o $status = T && echo "$name" && continue
675 # Also show added or modified modules which are checked out
676 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
677 echo "$name"
678 done
679 )
680
681 test -z "$modules" && return
682
683 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
684 sane_egrep '^:([0-7]* )?160000' |
685 cut -c2- |
686 while read mod_src mod_dst sha1_src sha1_dst status name
687 do
688 if test -z "$cached" &&
689 test $sha1_dst = 0000000000000000000000000000000000000000
690 then
691 case "$mod_dst" in
692 160000)
693 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
694 ;;
695 100644 | 100755 | 120000)
696 sha1_dst=$(git hash-object $name)
697 ;;
698 000000)
699 ;; # removed
700 *)
701 # unexpected type
702 (
703 eval_gettext "unexpected mode \$mod_dst" &&
704 echo
705 ) >&2
706 continue ;;
707 esac
708 fi
709 missing_src=
710 missing_dst=
711
712 test $mod_src = 160000 &&
713 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
714 missing_src=t
715
716 test $mod_dst = 160000 &&
717 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
718 missing_dst=t
719
720 total_commits=
721 case "$missing_src,$missing_dst" in
722 t,)
723 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_src")"
724 ;;
725 ,t)
726 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_dst")"
727 ;;
728 t,t)
729 errmsg="$(eval_gettext " Warn: \$name doesn't contain commits \$sha1_src and \$sha1_dst")"
730 ;;
731 *)
732 errmsg=
733 total_commits=$(
734 if test $mod_src = 160000 -a $mod_dst = 160000
735 then
736 range="$sha1_src...$sha1_dst"
737 elif test $mod_src = 160000
738 then
739 range=$sha1_src
740 else
741 range=$sha1_dst
742 fi
743 GIT_DIR="$name/.git" \
744 git rev-list --first-parent $range -- | wc -l
745 )
746 total_commits=" ($(($total_commits + 0)))"
747 ;;
748 esac
749
750 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
751 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
752 if test $status = T
753 then
754 blob="$(gettext "blob")"
755 submodule="$(gettext "submodule")"
756 if test $mod_dst = 160000
757 then
758 echo "* $name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
759 else
760 echo "* $name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
761 fi
762 else
763 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
764 fi
765 if test -n "$errmsg"
766 then
767 # Don't give error msg for modification whose dst is not submodule
768 # i.e. deleted or changed to blob
769 test $mod_dst = 160000 && echo "$errmsg"
770 else
771 if test $mod_src = 160000 -a $mod_dst = 160000
772 then
773 limit=
774 test $summary_limit -gt 0 && limit="-$summary_limit"
775 GIT_DIR="$name/.git" \
776 git log $limit --pretty='format: %m %s' \
777 --first-parent $sha1_src...$sha1_dst
778 elif test $mod_dst = 160000
779 then
780 GIT_DIR="$name/.git" \
781 git log --pretty='format: > %s' -1 $sha1_dst
782 else
783 GIT_DIR="$name/.git" \
784 git log --pretty='format: < %s' -1 $sha1_src
785 fi
786 echo
787 fi
788 echo
789 done |
790 if test -n "$for_status"; then
791 if [ -n "$files" ]; then
792 gettext "# Submodules changed but not updated:"; echo
793 else
794 gettext "# Submodule changes to be committed:"; echo
795 fi
796 echo "#"
797 sed -e 's|^|# |' -e 's|^# $|#|'
798 else
799 cat
800 fi
801}
802#
803# List all submodules, prefixed with:
804# - submodule not initialized
805# + different revision checked out
806#
807# If --cached was specified the revision in the index will be printed
808# instead of the currently checked out revision.
809#
810# $@ = requested paths (default to all)
811#
812cmd_status()
813{
814 # parse $args after "submodule ... status".
815 orig_flags=
816 while test $# -ne 0
817 do
818 case "$1" in
819 -q|--quiet)
820 GIT_QUIET=1
821 ;;
822 --cached)
823 cached=1
824 ;;
825 --recursive)
826 recursive=1
827 ;;
828 --)
829 shift
830 break
831 ;;
832 -*)
833 usage
834 ;;
835 *)
836 break
837 ;;
838 esac
839 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
840 shift
841 done
842
843 module_list "$@" |
844 while read mode sha1 stage path
845 do
846 name=$(module_name "$path") || exit
847 url=$(git config submodule."$name".url)
848 displaypath="$prefix$path"
849 if test "$stage" = U
850 then
851 say "U$sha1 $displaypath"
852 continue
853 fi
854 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
855 then
856 say "-$sha1 $displaypath"
857 continue;
858 fi
859 set_name_rev "$path" "$sha1"
860 if git diff-files --ignore-submodules=dirty --quiet -- "$path"
861 then
862 say " $sha1 $displaypath$revname"
863 else
864 if test -z "$cached"
865 then
866 sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
867 set_name_rev "$path" "$sha1"
868 fi
869 say "+$sha1 $displaypath$revname"
870 fi
871
872 if test -n "$recursive"
873 then
874 (
875 prefix="$displaypath/"
876 clear_local_git_env
877 cd "$path" &&
878 eval cmd_status "$orig_args"
879 ) ||
880 die "$(eval_gettext "Failed to recurse into submodule path '\$path'")"
881 fi
882 done
883}
884#
885# Sync remote urls for submodules
886# This makes the value for remote.$remote.url match the value
887# specified in .gitmodules.
888#
889cmd_sync()
890{
891 while test $# -ne 0
892 do
893 case "$1" in
894 -q|--quiet)
895 GIT_QUIET=1
896 shift
897 ;;
898 --)
899 shift
900 break
901 ;;
902 -*)
903 usage
904 ;;
905 *)
906 break
907 ;;
908 esac
909 done
910 cd_to_toplevel
911 module_list "$@" |
912 while read mode sha1 stage path
913 do
914 name=$(module_name "$path")
915 url=$(git config -f .gitmodules --get submodule."$name".url)
916
917 # Possibly a url relative to parent
918 case "$url" in
919 ./*|../*)
920 url=$(resolve_relative_url "$url") || exit
921 ;;
922 esac
923
924 say "$(eval_gettext "Synchronizing submodule url for '\$name'")"
925 git config submodule."$name".url "$url"
926
927 if test -e "$path"/.git
928 then
929 (
930 clear_local_git_env
931 cd "$path"
932 remote=$(get_default_remote)
933 git config remote."$remote".url "$url"
934 )
935 fi
936 done
937}
938
939# This loop parses the command line arguments to find the
940# subcommand name to dispatch. Parsing of the subcommand specific
941# options are primarily done by the subcommand implementations.
942# Subcommand specific options such as --branch and --cached are
943# parsed here as well, for backward compatibility.
944
945while test $# != 0 && test -z "$command"
946do
947 case "$1" in
948 add | foreach | init | update | status | summary | sync)
949 command=$1
950 ;;
951 -q|--quiet)
952 GIT_QUIET=1
953 ;;
954 -b|--branch)
955 case "$2" in
956 '')
957 usage
958 ;;
959 esac
960 branch="$2"; shift
961 ;;
962 --cached)
963 cached="$1"
964 ;;
965 --)
966 break
967 ;;
968 -*)
969 usage
970 ;;
971 *)
972 break
973 ;;
974 esac
975 shift
976done
977
978# No command word defaults to "status"
979test -n "$command" || command=status
980
981# "-b branch" is accepted only by "add"
982if test -n "$branch" && test "$command" != add
983then
984 usage
985fi
986
987# "--cached" is accepted only by "status" and "summary"
988if test -n "$cached" && test "$command" != status -a "$command" != summary
989then
990 usage
991fi
992
993"cmd_$command" "$@"